// Copyright (c) The Geekeey Authors
// SPDX-License-Identifier: EUPL-1.2

namespace Geekeey.Extensions.Result.Tests;

[TestFixture]
internal sealed class ErrorTests
{
	[Test]
	public void I_can_implicitly_convert_from_string_and_get_string_error()
	{
		Error error = "error";

		Assert.Multiple(() =>
		{
			Assert.That(error, Is.InstanceOf<StringError>());
			Assert.That(error.Message, Is.EqualTo("error"));
		});
	}

	[Test]
	public void I_can_implicitly_convert_from_exception_and_get_exception_error()
	{
		Error error = new CustomTestException();

		Assert.Multiple(() =>
		{
			Assert.That(error, Is.InstanceOf<ExceptionError>());
			var instance = error as ExceptionError;
			Assert.That(instance?.Exception, Is.InstanceOf<CustomTestException>());
		});
	}
}